// Commands.h

#pragma once

#include "Mobile.h"
#include "Skills.h"

using namespace System;

namespace SkillSystem
{
  // NOTE: sizeof(short) == 2
  // NOTE: sizeof(Int32) == 4

  public ref class Commands
  {
  public:
    static Int32 getCurHP (Object ^);
    static Int32 getMaxHP (Object ^);
    static Int32 getCurFatigue (Object ^);
    static Int32 getMaxFatigue (Object ^);
    static Int32 getCurMana (Object ^);
    static Int32 getMaxMana (Object ^);

    static Int32 getSkillTotal (Object ^);
    static Int32 getCappedSkillTotal (Object ^);

    static Int32 getHPLevel (Object ^);
    static Int32 getFatigueLevel (Object ^);
    static Int32 getManaLevel (Object ^);

    static void setCurHP (Object ^, Int32);
    static void setMaxHP (Object ^, Int32);
    static void handleHealthGain (Object ^);
    static void setCurFatigue (Object ^, Int32);
    static void setMaxFatigue (Object ^, Int32);
    static void setCurMana (Object ^, Int32);
    static void setMaxMana (Object ^, Int32);

    static void addHP (Object ^, Int32);
    static void addMana (Object ^, Int32);
    static void addFatigue (Object ^, Int32);
    static void loseHP (Object ^, Int32);
    static void loseMana (Object ^, Int32);
    static void loseFatigue (Object ^, Int32);
    static void restoreMobile (Object ^);
    static void restoreFatigue (Object ^);
    static void restoreHP (Object ^);
    static void restoreMana (Object ^);

    static Int32 getRealStrength (Object ^);
    static Int32 getRealDexterity (Object ^);
    static Int32 getRealIntelligence (Object ^);

    static Int32 getStrength (Object ^);
    static Int32 getDexterity (Object ^);
    static Int32 getIntelligence (Object ^);

    static Int32 getStat (Object ^, Int32);
    static Int32 getRealstat (Object ^, Int32);

    static Int32 getStatAttributeMax (Object ^, Int32);
    static Int32 setStatAttributeMax (Object ^, Int32, Int32);

    static Int32 modifyStat (Object ^, Int32, Int32);
    static Int32 modifyRealStat (Object ^, Int32, Int32);
    static Int32 setRealStat (Object ^, Int32, Int32);
    static Int32 getStatMod (Object ^, Int32);
    static Int32 setStatMod (Object ^, Int32, Int32);

    static Int32 getSkillMod (Object ^, Int32);
    static Int32 setSkillMod (Object ^, Int32, Int32);

    static Int32 testSkill (Object ^, Int32);
    static Int32 skillTest (Object ^, Int32);
    static Int32 testSkillReal (Object ^, Int32);
    static Int32 skillTestReal (Object ^, Int32);

    static Int32 getSkillLevel (Object ^, Int32);
    static Int32 getSkillLevelReal (Object ^, Int32);
    static Int32 getSkillLevelRealStat (Object ^, Int32);
    static Int32 getSkillLevelNoStat (Object ^, Int32);
    static Int32 getSkillLevelNoStatNoMod (Object ^, Int32);

    static void setSkillLevel (Object ^, Int32, Int32);
    static void addSkillLevel (Object ^, Int32, Int32);
    static void loseSkillLevel (Object ^, Int32, Int32);
    static Int32 modifySkillMod (Object ^, Int32, Int32);

    static Int32 getSkillNumber (String ^);
    static String ^ getSkillName (Int32);

    static void handleWatchingSkill (Object ^, Int32);
    static Int32 testAndlearnSkill (Object ^, Int32, Int32, Int32);
    static Int32 getSkillSuccessChance (Object ^, Int32, Int32, Int32);

    static Int32 setSkillLevel_Unused (Object ^, Int32, Int32);
    static Int32 addSkillLevel_Unused (Object ^, Int32, Int32);
    static Int32 loseSkillLevel_Unused (Object ^, Int32, Int32);
  };
}