#include "stdafx.h"

#include "Global.h"

namespace SkillSystem
{

static int rand()
{
  Random Randomizer;
  return Randomizer.Next(65536);
}

static Global::Global()
{
  Skills = gcnew SkillSystem::Skills;
}

int Global::GetRandomizedTaskTotalInMinutes(int Min_aka_Zero, int Max_aka_TaskTotalInMinutes)
{
  if(Max_aka_TaskTotalInMinutes < Min_aka_Zero)
    return 0;

  return Min_aka_Zero + Random64bit() % (Max_aka_TaskTotalInMinutes - Min_aka_Zero + 1);
}

__int64 Global::Random64bit()
{
  // Once upon a time...
  // ... rand() used to return a 16-bit number.
  // So that's why OSI used it 4 times to create a 64-bit random number...
  unsigned int lower = (unsigned int) (rand() << 16) | rand();
  unsigned int upper = (unsigned int) (rand() << 16) | rand();
  return __int64((unsigned __int64(upper) << 32) | lower);
}

void Global::InitStatCurve(int StatCurve)
{
  double temp;

  double LowStatPoints  =  65.0;
  double HighStatPoints = 170.0;
  double MaxStatPoints  = 225.0;
  double LowStatCurve =    0.0;
  double HighStatCurve = StatCurve;
  double MaxStatCurve = 1000.0;

  StatCurveLow = LowStatCurve;  
  StatPointsLow = LowStatPoints;
  temp = HighStatPoints - LowStatPoints;
  StatFormula_LowToHigh = (HighStatCurve - LowStatCurve) / (temp * temp);
  StatPointsHigh_ForCompare = HighStatPoints;
  StatCurveHigh = HighStatCurve;
  StatPointsHigh_ForSubstract = HighStatPoints;
  temp = MaxStatPoints - HighStatPoints;
  StatFormula_HighToMax = (MaxStatCurve - HighStatCurve) / (temp * temp);
}

void Global::InitSkillCurve(int SkillCurve)
{
  double temp;

  double LowSkillPoints  = 1000.0;
  double HighSkillPoints = 6000.0;
  double MaxSkillPoints  = 7000.0;
  double LowSkillCurve =    0.0;
  double HighSkillCurve = SkillCurve;
  double MaxSkillCurve = 1000.0;

  SkillCurveLow = LowSkillCurve;  
  SkillPointsLow = LowSkillPoints;
  temp = HighSkillPoints - LowSkillPoints;
  SkillFormula_LowToHigh = (HighSkillCurve - LowSkillCurve) / (temp * temp);
  SkillPointsHigh_ForCompare = HighSkillPoints;
  SkillCurveHigh = HighSkillCurve;
  SkillPointsHigh_ForSubstract = HighSkillPoints;
  temp = MaxSkillPoints - HighSkillPoints;
  SkillFormula_HighToMax = (MaxSkillCurve - HighSkillCurve) / (temp * temp);
}

int Global::ApplySkillCurve(int ValueToApply_int)
{
  double ValueToApply = (double) ValueToApply_int;
  if( ValueToApply > SkillPointsHigh_ForCompare)
    return int((ValueToApply - SkillPointsHigh_ForSubstract) * (ValueToApply - SkillPointsHigh_ForSubstract) * SkillFormula_HighToMax + SkillCurveHigh);
  else
    return int((ValueToApply - SkillPointsLow) * (ValueToApply - SkillPointsLow) * SkillFormula_LowToHigh + SkillCurveLow);
}

}