// Global.h

#pragma once

#include "Skills.h"

namespace SkillSystem
{
  public ref class Global abstract sealed 
  {
  public:
    static public Skills^ Skills;
    static Global();
    
  public:
    static public UInt32 ServerLoop_TickCount;

    // Server
    static public unsigned int GetTimeSecs() { return ServerLoop_TickCount / 1000; }
    static public int GetRandomizedTaskTotalInMinutes(int Min_aka_Zero, int Max_aka_TaskTotalInMinutes);
    static public __int64 Random64bit();

    // Related to StatCurve
    static public double StatCurveLow, StatCurveHigh;
    static public double StatPointsLow, StatPointsHigh_ForCompare, StatPointsHigh_ForSubstract;
    static public double StatFormula_LowToHigh, StatFormula_HighToMax;

    // Related to SkillCurve
    static public double SkillCurveLow, SkillCurveHigh;
    static public double SkillPointsLow, SkillPointsHigh_ForCompare, SkillPointsHigh_ForSubstract;
    static public double SkillFormula_LowToHigh, SkillFormula_HighToMax;

    static public void InitStatCurve(int StatCurve);
    static public void InitSkillCurve(int SkillCurve);

    static int ApplySkillCurve(int ValueToApply);
  };
}