// Skills.h

#pragma once

#include "Skill.h"

using namespace System::Collections::Generic;

namespace SkillSystem
{
  #define MAXIMUM_SUPPORTED_SKILLS (50)

  ref class Mobile;

  public ref class Skills
  {
  private:
    List<Skill^> SkillList;
    array<unsigned int> ^ PerSkillSomeValue;
    unsigned int AllSkillSomeTotal;
    array<unsigned int> ^ PerSkillUsageCounter;
    unsigned int AllSkillUsageCounter;

	public:
		unsigned int j;
		
	  Skills();

    void Clear();

    property int Count { int get(); }
    Skill^ operator[](int i);
    int operator[](String ^Name) { return FindSkill(Name); }
 
		int AddSkill(Skill ^Skill);
    int FindSkill(String ^Name);

  public:
    bool IsSkillEnabled(char SkillNumber)   { return SkillNumber < 0 || SkillNumber >= MAXIMUM_SUPPORTED_SKILLS ? false : this[SkillNumber]->IsSkillEnabled(); }
    Skill^ GetSkillObject(char SkillNumber) { return this[SkillNumber]; }

    unsigned int GetCombinedCounters() { return AllSkillSomeTotal + AllSkillUsageCounter; }
    unsigned int GetTotalSkillCount() { return SkillList.Count; }
    unsigned int GetCombinedValue(char SkillNumber)
    {
      IsSkillEnabled(SkillNumber); // LOL
      return PerSkillSomeValue[SkillNumber] + PerSkillUsageCounter[SkillNumber];
    }

    int GetSkillAdvRate(char SkillNumber, int BaseSkill);
    void RegisterSkillUsage(char SkillNumber);

  public: // Other
    void SendSkillChangePacket(Mobile ^Mobile, char SkillNumber);

    static unsigned int MaximumSupportedSkills() { return MAXIMUM_SUPPORTED_SKILLS; }
	};
}
